hpp-constraints: hpp::constraints::QPStaticStability Class Reference

hpp-constraints 9.0.2 Definition of basic geometric constraints for motion planning

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
hpp::constraints::QPStaticStability Class Reference
Constraints

`#include <hpp/constraints/qp-static-stability.hh>`

Inheritance diagram for hpp::constraints::QPStaticStability:
[legend]
Collaboration diagram for hpp::constraints::QPStaticStability:
[legend]

## Public Types
typedef StaticStability::Contact_t | Contact_t
typedef StaticStability::Contacts_t | Contacts_t
typedef ConvexShapeContact::ForceData | ForceData

## Public Member Functions
| QPStaticStability (const std::string &name, const DevicePtr_t &robot, const Contacts_t &contacts, const CenterOfMassComputationPtr_t &com)
| QPStaticStability (const std::string &name, const DevicePtr_t &robot, const std::vector< ForceData > &contacts, const CenterOfMassComputationPtr_t &com)
MatrixOfExpressions & | phi ()
Public Member Functions inherited from hpp::constraints::DifferentiableFunction
virtual | ~DifferentiableFunction ()
LiegroupElement | operator() (vectorIn_t argument) const
void | value (LiegroupElementRef result, vectorIn_t argument) const
void | jacobian (matrixOut_t jacobian, vectorIn_t argument) const
const ArrayXb & | activeParameters () const
const ArrayXb & | activeDerivativeParameters () const
size_type | inputSize () const
| Get dimension of input vector.
size_type | inputDerivativeSize () const
LiegroupSpacePtr_t | outputSpace () const
| Get output space.
size_type | outputSize () const
| Get dimension of output vector.
size_type | outputDerivativeSize () const
| Get dimension of output derivative vector.
const std::string & | name () const
| Get function name.
virtual std::ostream & | print (std::ostream &o) const
| Display object in a stream.
std::string | context () const
void | context (const std::string &c)
void | finiteDifferenceForward (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
void | finiteDifferenceCentral (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
bool | operator== (DifferentiableFunction const &other) const
bool | operator!= (DifferentiableFunction const &b) const
virtual std::pair< JointConstPtr_t, JointConstPtr_t > | dependsOnRelPoseBetween (DeviceConstPtr_t) const

## Static Public Member Functions
static QPStaticStabilityPtr_t | create (const std::string &name, const DevicePtr_t &robot, const Contacts_t &contacts, const CenterOfMassComputationPtr_t &com)
static QPStaticStabilityPtr_t | create (const std::string &name, const DevicePtr_t &robot, const std::vector< ForceData > &contacts, const CenterOfMassComputationPtr_t &com)
static QPStaticStabilityPtr_t | create (const DevicePtr_t &robot, const Contacts_t &contacts, const CenterOfMassComputationPtr_t &com)
Static Public Member Functions inherited from hpp::constraints::DifferentiableFunction
static DifferentiableFunctionPtr_t | extract (DifferentiableFunctionPtr_t original, interval_t interval)

## Static Public Attributes
static const Eigen::Matrix< value_type, 6, 1 > | Gravity

## Protected Member Functions
bool | isEqual (const DifferentiableFunction &other) const
Protected Member Functions inherited from hpp::constraints::DifferentiableFunction
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, size_type sizeOutput, std::string name=std::string())
| Concrete class constructor should call this constructor.
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, const LiegroupSpacePtr_t &outputSpace, std::string name=std::string())
| Concrete class constructor should call this constructor.
virtual void | impl_compute (LiegroupElementRef result, vectorIn_t argument) const =0
| User implementation of function evaluation.
virtual void | impl_jacobian (matrixOut_t jacobian, vectorIn_t arg) const =0
| DifferentiableFunction ()

## Additional Inherited Members
Protected Attributes inherited from hpp::constraints::DifferentiableFunction
size_type | inputSize_
| Dimension of input vector.
size_type | inputDerivativeSize_
| Dimension of input derivative.
LiegroupSpacePtr_t | outputSpace_
| Dimension of output vector.
ArrayXb | activeParameters_
ArrayXb | activeDerivativeParameters_

## Detailed Description

Quasi static equilibrium constraint defined as a QP program

This class defines a function whose value is equal to zero if and only if there exists a set of non-negative forces applied at some given contact points along some given normals that

See also
  https://hal.archives-ouvertes.fr/tel-01516897 Chapter 2, Sections 3.1 and 3.2.

## Member Typedef Documentation

## ◆ Contact_t

typedef StaticStability::Contact_t hpp::constraints::QPStaticStability::Contact_t

## ◆ Contacts_t

typedef StaticStability::Contacts_t hpp::constraints::QPStaticStability::Contacts_t

## ◆ ForceData

typedef ConvexShapeContact::ForceData hpp::constraints::QPStaticStability::ForceData

## Constructor & Destructor Documentation

## ◆ QPStaticStability() [1/2]

hpp::constraints::QPStaticStability::QPStaticStability | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const Contacts_t & | contacts,
|  | const CenterOfMassComputationPtr_t & | com )

Constructor

Parameters

  name | name of the constraint
  robot | the robot the constraints is applied to,
  contacts | set of contact points
  com | COM of the robot

## ◆ QPStaticStability() [2/2]

hpp::constraints::QPStaticStability::QPStaticStability | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const std::vector< ForceData > & | contacts,
|  | const CenterOfMassComputationPtr_t & | com )

Constructor

Parameters

  robot | the robot the constraints is applied to,
  com | COM of the robot

## Member Function Documentation

## ◆ create() [1/3]

static QPStaticStabilityPtr_t hpp::constraints::QPStaticStability::create | ( | const DevicePtr_t & | robot,
|  | const Contacts_t & | contacts,
|  | const CenterOfMassComputationPtr_t & | com )
| static

## ◆ create() [2/3]

static QPStaticStabilityPtr_t hpp::constraints::QPStaticStability::create | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const Contacts_t & | contacts,
|  | const CenterOfMassComputationPtr_t & | com )
| static

## ◆ create() [3/3]

static QPStaticStabilityPtr_t hpp::constraints::QPStaticStability::create | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const std::vector< ForceData > & | contacts,
|  | const CenterOfMassComputationPtr_t & | com )
| static

## ◆ isEqual()

bool hpp::constraints::QPStaticStability::isEqual | ( | const DifferentiableFunction & | other | ) | const
| inline protected virtual

Reimplemented from hpp::constraints::DifferentiableFunction.

## ◆ phi()

MatrixOfExpressions & hpp::constraints::QPStaticStability::phi | ( |  | ) |
| inline

## Member Data Documentation

## ◆ Gravity

const Eigen::Matrix<value_type, 6, 1> hpp::constraints::QPStaticStability::Gravity
| static

The documentation for this class was generated from the following file:

- include/hpp/constraints/qp-static-stability.hh